#-----------------------------------------------------------------------------
# Project  Tutoriels - Conception de circuits intégrés numériques
#-----------------------------------------------------------------------------
# File     dft_fullscan.non_scan_mode.sdc
# Authors  Erika Miller-Jolicoeur <erika.miller-jolicoeur@polymtl.ca>
# Lab      GRM - Polytechnique Montréal
# Date     <2020-07-23>
#-----------------------------------------------------------------------------
# Brief    Contraintes de timing avec chaîne FULLSCAN en mode fonctionnel (non scan)
#-----------------------------------------------------------------------------

# Chaîne à balayage
set_false_path -from [get_ports i_tdi]
set_false_path -to [get_ports o_tdo]
   
# Valeur des signaux scan_en et test_mode pour désactiver la chaîne
set_case_analysis 0 [get_ports i_scan_en]
set_case_analysis 0 [get_ports i_test_mode]

# Entrée pour le test
set_input_delay 200 -clock [get_clocks clk] [list i_tdi i_scan_en i_test_mode]
set_db [get_ports [list i_tdi i_scan_en i_test_mode]] \
    .external_driver [vfind [vfind / -libcell BUFX20] -libpin Y]

# Sorties pour le test
set_output_delay 200 -clock [get_clocks clk] [get_ports o_tdo]
set_db [get_ports o_tdo] .external_pin_cap 500
