//***************************************************************************//
//                           VERILOG MAINSIM FILE                            //
//Cadence(R) Modus(TM) DFT Software Solution, Version 19.12-s004_1, built Dec//
//***************************************************************************//
//                                                                           //
//  FILE CREATED..............August 25, 2020 at 22:59:40                    //
//                                                                           //
//  PROJECT NAME..............syn                                            //
//                                                                           //
//  TESTMODE..................FULLSCAN                                       //
//                                                                           //
//  TDR.......................dummy.tdr                                      //
//                                                                           //
//  TEST PERIOD...............80000.000TEST TIME UNITS...........ps          //
//  TEST PULSE WIDTH..........8000.000                                       //
//  TEST STROBE OFFSET........72000.000TEST STROBE TYPE..........edge        //
//  TEST BIDI OFFSET..........0.000                                          //
//  TEST PI OFFSET............0.000    X VALUE...................X           //
//                                                                           //
//  SCAN FORMAT...............parallel SCAN OVERLAP..............yes         //
//  SCAN PERIOD...............80000.000SCAN TIME UNITS...........ps          //
//  SCAN PULSE WIDTH..........8000.000                                       //
//  SCAN STROBE OFFSET........8000.000 SCAN STROBE TYPE..........edge        //
//  SCAN BIDI OFFSET..........0.000                                          //
//  SCAN PI OFFSET............0.000    X VALUE...................X           //
//                                                                           //
//                                                                           //
//   Individually set PIs                                                    //
//  "i_clk" (PI # 1)                                                         //
//  TEST OFFSET...............8000.000 PULSE WIDTH...............8000.000    //
//  SCAN OFFSET...............16000.000PULSE WIDTH...............8000.000    //
//                                                                           //
//  "i_rstn" (PI # 3)                                                        //
//  TEST OFFSET...............8000.000 PULSE WIDTH...............8000.000    //
//  SCAN OFFSET...............0.000                                          //
//                                                                           //
//  Active TESTMODEs TM = 1 ..FULLSCAN                                       //
//                                                                           //
//***************************************************************************//

  `timescale 1 ps / 1 fs

  module syn_FULLSCAN ;

//***************************************************************************//
//                DEFINE VARIABLES FOR ALL PRIMARY I/O PORTS                 //
//***************************************************************************//

  reg [1:6] stim_PIs;   
  reg [1:6] part_PIs;   

  reg [1:6] stim_CIs;   

  reg [1:5] meas_POs;   

  reg [1:5] scan_POs;   
  wire [1:5] part_POs;   

//***************************************************************************//
//                   DEFINE VARIABLES FOR ALL SHIFT CHAINS                   //
//***************************************************************************//

  reg [1:6] stim_CR_1;   

  reg [1:6] meas_OR_1;   

  reg [1:6] part_S_CR_1_TM_1;   

  wire [1:6] part_M_OR_1_TM_1;   


//***************************************************************************//
//                             OTHER DEFINITIONS                             //
//***************************************************************************//

  integer  CYCLE, SCANCYCLE, SERIALCYCLE, PInum, POnum, ORnum, MODENUM, EXPNUM, SCANOPNUM, SEQNUM, TASKNUM, START, NUM_SHIFTS, MultiShift, maxMultiShifts, MultiShiftsLeft, forcePointStart, forcePoint, SCANNUM ; 
  integer  CMD, DATAID, SAVEID, TID, rc_read, repeat_depth, repeat_heart, repeat_num, MAX, FAILSETID, DIAG_DATAID; 
  integer  num_repeats [1:15]; 
  reg      [1:8185] name_POs [1:5]; 
  reg      [130:0] good_compares, miscompares, miscompare_limit, total_good_compares, total_miscompares, measure_current; 
  reg      [130:0] start_of_repeat [1:15]; 
  reg      [130:0] start_of_current_line, line_number, save_line_number, fseek_offset; 
  reg      sim_trace, sim_heart, sim_range, failset, global_term, sim_debug, sim_more_debug, diag_debug; 
  reg      [1:800] PATTERN, pattern, TESTFILE, INITFILE, SOD, EOD, eventID, DIAG_DEBUG_FILE; 
  reg      [1:8184] DATAFILE, SAVEFILE, COMMENT, FAILSET; 
  reg      [1:4096] PROCESSNAME; 

//***************************************************************************//
//        INSTANTIATE THE STRUCTURE AND CONNECT TO VERILOG VARIABLES         //
//***************************************************************************//

  compteur
    compteur_inst (
      .i_clk       ( part_PIs[1] ),      // pinName = i_clk;  tf = -ES  ; testOffset = 8000.000000;  scanOffset = 16000.000000;  
      .i_rstn      ( part_PIs[3] ),      // pinName = i_rstn;  tf = +SC  ; testOffset = 8000.000000;  scanOffset = 0.000000;  
      .i_en        ( part_PIs[2] ),      // pinName = i_en; testOffset = 0.000000;  scanOffset = 0.000000;  
      .o_cnt       ({part_POs[4]  ,      // pinName = o_cnt[3]; 
                     part_POs[3]  ,      // pinName = o_cnt[2]; 
                     part_POs[2]  ,      // pinName = o_cnt[1]; 
                     part_POs[1]}),      // pinName = o_cnt[0]; 
      .i_scan_en   ( part_PIs[4] ),      // pinName = i_scan_en;  tf = +SE  ; testOffset = 0.000000;  scanOffset = 0.000000;  
      .i_test_mode ( part_PIs[6] ),      // pinName = i_test_mode;  tf = +TI  ; testOffset = 0.000000;  scanOffset = 0.000000;  
      .i_tdi       ( part_PIs[5] ),      // pinName = i_tdi;  tf =  SI  ; testOffset = 0.000000;  scanOffset = 0.000000;  
      .o_tdo       ( part_POs[5] )     // pinName = o_tdo;  tf =  SO  ; 
      );

//***************************************************************************//
//                        MAKE SOME OTHER CONNECTIONS                        //
//***************************************************************************//

  assign ( weak0, weak1 ) // Termination 
    part_POs [1] = global_term,     // pinName = o_cnt[0]; 
    part_POs [2] = global_term,     // pinName = o_cnt[1]; 
    part_POs [3] = global_term,     // pinName = o_cnt[2]; 
    part_POs [4] = global_term,     // pinName = o_cnt[3]; 
    part_POs [5] = global_term;      // pinName = o_tdo;  tf =  SO  ; 


  assign ( supply0, supply1 ) // CR = 1 
    compteur_inst.i_tdi = part_S_CR_1_TM_1 [6] ,   // CR = 1;  pos = 1;  Pin Index = 4;  Pin Name = i_tdi;  pinInvFromLatch = no;  Latch Index = 136;  Latch Name = \rstn_sync_reg[0].__iNsT6.dff_primitive;   
    compteur_inst.\rstn_sync_reg[1] .D = part_S_CR_1_TM_1 [5] ,   // CR = 1;  pos = 2;  Pin Index = 421;  Pin Name = \rstn_sync_reg[1].D;  pinInvFromLatch = no;  Latch Index = 156;  Latch Name = \rstn_sync_reg[1].__iNsT2.dff_primitive;   
    compteur_inst.\cnt_reg[0] .SI = part_S_CR_1_TM_1 [4] ,   // CR = 1;  pos = 3;  Pin Index = 44;  Pin Name = \cnt_reg[0].SI;  pinInvFromLatch = no;  Latch Index = 32;  Latch Name = \cnt_reg[0].__iNsT6.dff_primitive;   
    compteur_inst.\cnt_reg[1] .SI = part_S_CR_1_TM_1 [3] ,   // CR = 1;  pos = 4;  Pin Index = 120;  Pin Name = \cnt_reg[1].SI;  pinInvFromLatch = no;  Latch Index = 58;  Latch Name = \cnt_reg[1].__iNsT6.dff_primitive;   
    compteur_inst.\cnt_reg[2] .SI = part_S_CR_1_TM_1 [2] ,   // CR = 1;  pos = 5;  Pin Index = 196;  Pin Name = \cnt_reg[2].SI;  pinInvFromLatch = no;  Latch Index = 84;  Latch Name = \cnt_reg[2].__iNsT6.dff_primitive;   
    compteur_inst.\cnt_reg[3] .SI = part_S_CR_1_TM_1 [1] ;   // CR = 1;  pos = 6;  Pin Index = 272;  Pin Name = \cnt_reg[3].SI;  pinInvFromLatch = no;  Latch Index = 110;  Latch Name = \cnt_reg[3].__iNsT6.dff_primitive;   

  assign // OR = 1 
    part_M_OR_1_TM_1 [1] =  compteur_inst.o_tdo ,   // OR = 1;  pos = 1;  Pin Index = 10;  Pin Name = o_tdo;  pinInvFromLatch = no;  Latch Index = 110;  Latch Name = \cnt_reg[3].__iNsT6.dff_primitive;   
    part_M_OR_1_TM_1 [2] =  compteur_inst.\cnt_reg[2] .Q ,   // OR = 1;  pos = 2;  Pin Index = 197;  Pin Name = \cnt_reg[2].Q;  pinInvFromLatch = no;  Latch Index = 84;  Latch Name = \cnt_reg[2].__iNsT6.dff_primitive;   
    part_M_OR_1_TM_1 [3] =  compteur_inst.\cnt_reg[1] .Q ,   // OR = 1;  pos = 3;  Pin Index = 121;  Pin Name = \cnt_reg[1].Q;  pinInvFromLatch = no;  Latch Index = 58;  Latch Name = \cnt_reg[1].__iNsT6.dff_primitive;   
    part_M_OR_1_TM_1 [4] =  compteur_inst.\cnt_reg[0] .Q ,   // OR = 1;  pos = 4;  Pin Index = 45;  Pin Name = \cnt_reg[0].Q;  pinInvFromLatch = no;  Latch Index = 32;  Latch Name = \cnt_reg[0].__iNsT6.dff_primitive;   
    part_M_OR_1_TM_1 [5] =  compteur_inst.\rstn_sync_reg[1] .Q ,   // OR = 1;  pos = 5;  Pin Index = 423;  Pin Name = \rstn_sync_reg[1].Q;  pinInvFromLatch = no;  Latch Index = 156;  Latch Name = \rstn_sync_reg[1].__iNsT2.dff_primitive;   
    part_M_OR_1_TM_1 [6] =  compteur_inst.\rstn_sync_reg[0] .Q ;   // OR = 1;  pos = 6;  Pin Index = 349;  Pin Name = \rstn_sync_reg[0].Q;  pinInvFromLatch = no;  Latch Index = 136;  Latch Name = \rstn_sync_reg[0].__iNsT6.dff_primitive;   

//***************************************************************************//
//                     OPEN THE FILE AND RUN SIMULATION                      //
//***************************************************************************//

  initial 
    begin 

      $timeformat ( -12, 2, " ps", 10 ); 

      `ifdef sdf_annotate 
        `ifdef SDF_Minimum 
          $sdf_annotate ("default.sdf",compteur_inst,,"sdf_Min.log","MINIMUM");
        `endif 
        `ifdef SDF_Maximum 
          $sdf_annotate ("default.sdf",compteur_inst,,"sdf_Max.log","MAXIMUM");
        `endif 
        `ifdef SDF_Typical
          $sdf_annotate ("default.sdf",compteur_inst,,"sdf_Typ.log","TYPICAL");
        `endif 
      `endif 

      `ifndef NOT_NC 
        if ( $test$plusargs ( "simvision" ) )  begin 
          $shm_open("simvision.shm"); 
          $shm_probe("AC"); 
        end  
      `endif 

      if ( $test$plusargs ( "vcd" ) )  begin 
        $dumpfile("out.vcd"); 
        $dumpvars(0,syn_FULLSCAN ); 
      end  

      DATAFILE = 0; 
      sim_setup; 

      `ifdef MISCOMPAREDEBUG 
        diag_debug = 1'b0; 
        if ( $value$plusargs ( "MISCOMPAREDEBUGFILE=%s", DIAG_DEBUG_FILE )) begin 
          DIAG_DATAID = $fopen ( DIAG_DEBUG_FILE, "r" ); 
          if ( DIAG_DATAID ) begin 
            diag_debug = 1'b1; 
            $fclose ( DIAG_DATAID ); 
          end  
          else $display ( "\nERROR (TVE-951): Failed to open Diagnostic 'MISCOMPAREDEBUGFILE' file: %0s. \n", DIAG_DEBUG_FILE ); 
        end  
      `endif  

      for ( TID = 1; TID <= 99; TID = TID + 1 ) begin 
        $sformat ( TESTFILE, "TESTFILE%0d=%s", TID, "%s" ); 
        if ( $value$plusargs ( TESTFILE, DATAFILE )) begin 
          DATAID = $fopen ( DATAFILE, "r" ); 
          if ( DATAID )  sim_vector_file; 
          else $display ( "\nERROR (TVE-951): Failed to open the file: %0s. \n", DATAFILE ); 
        end  
      end  

      if ( FAILSETID )  $fclose ( FAILSETID ); 

      if ( DATAFILE )  begin
        $display ( "\nINFO (TVE-204): The total number of good comparing vectors is %0.0f ", total_good_compares ); 
        $display ( "\nINFO (TVE-203): The total number of miscomparing vectors is %0.0f \n", total_miscompares ); 
      end  
      else $display ( "\nWARNING (TVE-661): No input data files found. The data file must be specified using +TESTFILE1=<string>, +TESTFILE2=<string>, ... The +TESTFILEn=<string> keyword is an NC-Sim command. \n" ); 

      $finish; 

    end  

//***************************************************************************//
//                     DEFINE SIMULATION SETUP PROCEDURE                     //
//***************************************************************************//

  task sim_setup; 
    begin 

      total_good_compares = 0; 
      total_miscompares = 0; 
      miscompare_limit = 0; 
      SOD = ""; 
      EOD = ""; 
      START = 0; 
      NUM_SHIFTS = 0; 
      MAX = 1; 

      sim_heart = 1'b0; 
      sim_range = 1'b1; 
      sim_trace = 1'b0; 
      sim_debug = 1'b0; 
      sim_more_debug = 1'b0; 

      global_term = 1'bZ; 

      failset = 1'b0; 
      FAILSETID = 0; 

      CYCLE = 0; 
      SCANCYCLE = 0; 
      SERIALCYCLE = 0; 
      SEQNUM = 0; 
      name_POs [1] = "o_cnt[0]";      // pinName = o_cnt[0]; 
      name_POs [2] = "o_cnt[1]";      // pinName = o_cnt[1]; 
      name_POs [3] = "o_cnt[2]";      // pinName = o_cnt[2]; 
      name_POs [4] = "o_cnt[3]";      // pinName = o_cnt[3]; 
      name_POs [5] = "o_tdo";      // pinName = o_tdo;  tf =  SO  ; 



      if ( $test$plusargs ( "MODUS_DEBUG" ) )  sim_trace = 1'b1; 

      if ( $test$plusargs ( "HEARTBEAT" ) )  sim_heart = 1'b1; 

      if ( $value$plusargs ( "START_RANGE=%s", SOD ) )  sim_range = 1'b0; 

      if ( $value$plusargs ( "END_RANGE=%s", EOD ) ); 

      if ( $value$plusargs ( "miscompare_limit=%0f", miscompare_limit ) ); 

      if ( $test$plusargs ( "FAILSET" ) )  failset = 1'b1; 

      stim_PIs = {6{1'bX}};   
      stim_CIs = 6'b0X1XXX; 
      meas_POs = {5{1'bX}};   
      stim_CR_1 = {6{1'b0}};   
      part_S_CR_1_TM_1 = {6{1'bZ}};   
      meas_OR_1 = {6{1'bX}};   

    end  
  endtask  

//***************************************************************************//
//                          FAILSET SETUP PROCEDURE                          //
//***************************************************************************//

  task failset_setup; 
    begin 

      $sformat ( FAILSET, "%0s_FAILSET", DATAFILE ); 
      FAILSETID = $fopen ( FAILSET, "w" ); 
      if ( ! FAILSETID ) 
        $display ( "\nERROR (TVE-951): Failed to open the file: %0s. \n", FAILSET ); 

    end  
  endtask 

//***************************************************************************//
//                           SET UP FOR SIMULATION                           //
//***************************************************************************//

  task sim_vector_file; 
    begin 

      CYCLE = 0; 
      SCANCYCLE = 0; 
      SERIALCYCLE = 0; 
      good_compares = 0; 
      miscompares = 0; 
      measure_current = 0; 
      repeat_depth = 0; 
      repeat_heart = 1000; 


      $display ( "\nINFO (TVE-200): Reading vector file: %0s ", DATAFILE ); 

      start_of_current_line = $ftell ( DATAID ); 
      line_number = 1; 
      rc_read = $fscanf ( DATAID, "%d", CMD ); 
      while ( rc_read > 0 ) begin 

        cmd_code; 

        if ( rc_read > 0 )  begin 
          if ( sim_range )  begin 
            if (( miscompare_limit > 0 ) & ( miscompares > miscompare_limit ))  begin 
              sim_range = 1'b0; 
              $display ( "\nINFO (TVE-207): The miscompare limit (+miscompare_limit) of %0.0f has been reached. ", miscompare_limit ); 
            end  
            if ( EOD == pattern )  begin 
              sim_range = 1'b0; 
            end  
          end  
          start_of_current_line = $ftell ( DATAID ); 
          rc_read = $fscanf ( DATAID, "%d", CMD ); 
          if ( rc_read <= 0 )  begin 
            rc_read = $fgets ( COMMENT, DATAID ); 
            if ( rc_read > 0 )  bad_cmd_code; 
            else  line_number = 0; 
          end  
        end  
      end  

      if ( line_number == 0 )  begin
        $display ( "\nINFO (TVE-201): Simulation complete on vector file: %0s ", DATAFILE ); 
        $display ( "\nINFO (TVE-206): The number of good comparing vectors for the file just completed is %0.0f ", good_compares ); 
        $display ( "\nINFO (TVE-205): The number of miscomparing vectors for the file just completed is %0.0f \n", miscompares ); 
      end  

      $fclose ( DATAID ); 

      total_good_compares = total_good_compares + good_compares; 

      total_miscompares = total_miscompares + miscompares; 

    end  
  endtask  

//***************************************************************************//
//                           DEFINE TEST PROCEDURE                           //
//***************************************************************************//

  task test_cycle; 
    begin 

      CYCLE = CYCLE + 1; 
      SERIALCYCLE = SERIALCYCLE + 1; 
     #0.000000;        // 0.000000 ps;  From the start of the cycle.
      part_PIs [2] = stim_PIs [2];      // pinName = i_en; testOffset = 0.000000;  scanOffset = 0.000000;  
      part_PIs [4] = stim_PIs [4];      // pinName = i_scan_en;  tf = +SE  ; testOffset = 0.000000;  scanOffset = 0.000000;  
      part_PIs [5] = stim_PIs [5];      // pinName = i_tdi;  tf =  SI  ; testOffset = 0.000000;  scanOffset = 0.000000;  
      part_PIs [6] = stim_PIs [6];      // pinName = i_test_mode;  tf = +TI  ; testOffset = 0.000000;  scanOffset = 0.000000;  
     #8000.000000;        // 8000.000000 ps;  From the start of the cycle.
      part_PIs [1] = stim_PIs [1];      // pinName = i_clk;  tf = -ES  ; testOffset = 8000.000000;  scanOffset = 16000.000000;  
      part_PIs [3] = stim_PIs [3];      // pinName = i_rstn;  tf = +SC  ; testOffset = 8000.000000;  scanOffset = 0.000000;  
     #8000.000000;        // 16000.000000 ps;  From the start of the cycle.
      part_PIs [1] = stim_CIs [1];      // pinName = i_clk;  tf = -ES  ; testOffset = 8000.000000;  scanOffset = 16000.000000;  
      part_PIs [3] = stim_CIs [3];      // pinName = i_rstn;  tf = +SC  ; testOffset = 8000.000000;  scanOffset = 0.000000;  
     #56000.000000;        // 72000.000000 ps;  From the start of the cycle.

      for ( POnum = 1; POnum <= 5; POnum = POnum + 1 ) begin 
        if (( part_POs [ POnum ] !== meas_POs [ POnum ] ) & ( meas_POs [ POnum ] !== 1'bX )) begin 
          miscompares = miscompares + 1; 
          $display ( "\nWARNING (TVE-650): PO miscompare at pattern: %0s at Time: %0t ", PATTERN, $time ); 
          $display ( "           Expected: %0b   Simulated: %0b   On PO: %0s   ", meas_POs [ POnum ], part_POs [ POnum ], name_POs [ POnum ] ); 

          if (( failset ) & ( FAILSETID == 0 ))  failset_setup; 
          if ( FAILSETID ) begin 
            $fdisplay ( FAILSETID, " Chip %0s pad %0s pattern %0s position %0d value %0b ", "compteur", name_POs [ POnum ], PATTERN, -1, part_POs [ POnum ] ); 
          end  
        end  
        else if ( meas_POs [ POnum ] !== 1'bX )  good_compares = good_compares + 1; 
      end  
     #8000.000000;        // 80000.000000 ps;  From the start of the cycle.
      meas_POs = {5{1'bX}}; 

    end  
  endtask  

//***************************************************************************//
//                       DEFINE SCAN PRECOND PROCEDURE                       //
//***************************************************************************//

  task Scan_Preconditioning_Sequence_TM_1_SEQ_1_SOP_1; 
    begin 

      PROCESSNAME = "SCAN PRECONDITIONING (Scan_Preconditioning_Sequence)";
      stim_PIs [4] = 1'b1;      // pinName = i_scan_en;  tf = +SE  ; testOffset = 0.000000;  scanOffset = 0.000000;  

      test_cycle; 
      PROCESSNAME = "";
      PROCESSNAME = "";

    end  
  endtask  

//***************************************************************************//
//                      DEFINE SCAN SEQUENCE PROCEDURE                       //
//***************************************************************************//

  task Scan_Sequence_TM_1_SEQ_2_SOP_1; 
    begin 

      PROCESSNAME = "SCAN SEQUENCE (Scan_Sequence)";
      SERIALCYCLE = SERIALCYCLE + MAX; 
      CYCLE = CYCLE + 1; 
     #0.000000;        // 0.000000 ps;  From the start of the cycle.

      for ( SCANCYCLE = 1; SCANCYCLE <= MAX; SCANCYCLE = SCANCYCLE + 1 ) begin 

        if (( part_M_OR_1_TM_1 [ 0 + SCANCYCLE ] !== meas_OR_1 [ 0 + SCANCYCLE ] ) & ( meas_OR_1 [ 0 + SCANCYCLE ] !== 1'bX )) begin      // pinName = o_tdo;  tf =  SO  ; 
          miscompares = miscompares + 1; 
          $display ( "\nWARNING (TVE-660): Parallel scan miscompare at pattern: %0s at Time: %0t ", PATTERN, $time ); 
          $display ( "           Expected: %0b   Simulated: %0b   Observe Register (OR) = 1;   Measured on Scan Cycle: %0d   Feeds Scan Out: %0s   ", meas_OR_1 [ 0 + SCANCYCLE ], part_M_OR_1_TM_1 [ 0 + SCANCYCLE ], SCANCYCLE + 0, name_POs [5] ); 

          if (( failset ) & ( FAILSETID == 0 ))  failset_setup; 
          if ( FAILSETID ) begin 
            $fdisplay ( FAILSETID, " Chip %0s pad %0s pattern %0s position %0d value %0b ", "compteur", name_POs [5], PATTERN, SCANCYCLE, part_M_OR_1_TM_1 [ 0 + SCANCYCLE ] ); 
          end  
        end  
        else  begin 
          if ( meas_OR_1 [ 0 + SCANCYCLE ] !== 1'bX )  begin 
            good_compares = good_compares + 1;
          end 
        end 
      end  
     #0.000000;        // 0.000000 ps;  From the start of the cycle.
      part_S_CR_1_TM_1 [1:6] = stim_CR_1 [1:6]; 
     #16000.000000;        // 16000.000000 ps;  From the start of the cycle.
      part_PIs [1] = 1'b1;      // pinName = i_clk;  tf = -ES  ; testOffset = 8000.000000;  scanOffset = 16000.000000;  
     #8000.000000;        // 24000.000000 ps;  From the start of the cycle.
      part_PIs [1] = 1'b0;      // pinName = i_clk;  tf = -ES  ; testOffset = 8000.000000;  scanOffset = 16000.000000;  
     #56000.000000;        // 80000.000000 ps;  From the start of the cycle.
      part_S_CR_1_TM_1 = {6{1'bZ}};   
     #0; 
      meas_OR_1 = {6{1'bX}};   
      stim_CR_1 = {6{1'b0}};   
      stim_PIs = part_PIs; 
      SCANCYCLE = 0; 
      NUM_SHIFTS = 0; 
      PROCESSNAME = "";

    end  
  endtask  

//***************************************************************************//
//                        DEFINE TIMED TEST PROCEDURE                        //
//***************************************************************************//

  task TBphantomLogicSeq1_20200826025928__0; 
    begin 

      if ( sim_trace )  $display ( "\nRunning task:  TBphantomLogicSeq1_20200826025928__0 " ); 

      CYCLE = CYCLE + 1; 
      SERIALCYCLE = SERIALCYCLE + 1; 
     #25.000000;        // 25.000000 ps;  From the start of the cycle.
      part_PIs[1] = stim_PIs[1]; 
     #1200.000000;        // 1225.000000 ps;  From the start of the cycle.
      part_PIs[1] = stim_CIs[1]; 
     #7675.000000;        // 8900.000000 ps;  From the start of the cycle.
      stim_PIs[1] = 1'b0; 
      stim_PIs[3] = 1'b1; 

    end  
  endtask  

//***************************************************************************//
//                        DEFINE TIMED TEST PROCEDURE                        //
//***************************************************************************//

  task TBphantomLogicSeq1_20200826025928__1; 
    begin 

      if ( sim_trace )  $display ( "\nRunning task:  TBphantomLogicSeq1_20200826025928__1 " ); 

      CYCLE = CYCLE + 1; 
      SERIALCYCLE = SERIALCYCLE + 1; 
     #25.000000;        // 25.000000 ps;  From the start of the cycle.
      part_PIs[1] = stim_PIs[1]; 
     #1200.000000;        // 1225.000000 ps;  From the start of the cycle.
      part_PIs[1] = stim_CIs[1]; 
     #1275.000000;        // 2500.000000 ps;  From the start of the cycle.
      stim_PIs[1] = 1'b0; 
      stim_PIs[3] = 1'b1; 

    end  
  endtask  

//***************************************************************************//
//                 READ COMMANDS AND DATA AND RUN SIMULATION                 //
//***************************************************************************//

  task cmd_code; 
    begin 

      if ( sim_trace )  $display ( "\nCommand code:  %0d ", CMD ); 

      case ( CMD ) 

        000: begin 
          rc_read = 0;  // This will stop execution 
          line_number = line_number + 1; 
        end  

        100: begin 
          rc_read = $fgets ( COMMENT, DATAID ); 
          if ( rc_read > 0 )  begin 
          end  
          else  begin 
            $display ( "\nERROR (TVE-998): Unrecognizable data at line %0.0f in file: %0s \n", line_number, DATAFILE ); 
            $display ( "  Command code = %0d, Unrecognized data = %0s \n", CMD, COMMENT ); 
          end  
          line_number = line_number + 1; 
        end  

        104: begin 
          rc_read = $fgets ( PROCESSNAME, DATAID ); 
          if ( rc_read > 0 )  begin 
          end  
          else  begin 
            $display ( "\nERROR (TVE-998): Unrecognizable data at line %0.0f in file: %0s \n", line_number, DATAFILE ); 
            $display ( "  Command code = %0d, Unrecognized data = %0s \n", CMD, PROCESSNAME ); 
          end  
          line_number = line_number + 1; 
        end  

        110: begin 
          rc_read = $fgets ( COMMENT, DATAID ); 
          if ( rc_read > 0 )  begin 
            $display ( "\n %0s ", COMMENT ); 
          end  
          else  begin 
            $display ( "\nERROR (TVE-998): Unrecognizable data at line %0.0f in file: %0s \n", line_number, DATAFILE ); 
            $display ( "  Command code = %0d, Unrecognized data = %0s \n", CMD, COMMENT ); 
          end  
          line_number = line_number + 1; 
        end  

        200: begin 
          if ( rc_read > 0 )  begin 
            rc_read = $fscanf ( DATAID, "%b", stim_PIs [1:6] ); 
            if ( rc_read <= 0 )  bad_cmd_code; 
            line_number = line_number + 1; 
          end  
        end  

        201: begin 
          if ( rc_read > 0 )  begin 
            rc_read = $fscanf ( DATAID, "%b", stim_CIs [1:6] ); 
            if ( rc_read <= 0 )  bad_cmd_code; 
            line_number = line_number + 1; 
          end  
        end  

        202: begin 
          if ( rc_read > 0 )  begin 
            rc_read = $fscanf ( DATAID, "%b", meas_POs [1:5] ); 
            if ( rc_read <= 0 )  bad_cmd_code; 
            line_number = line_number + 1; 
          end  
        end  

        203: begin 
          rc_read = $fscanf ( DATAID, "%b", global_term ); 
          if ( rc_read > 0 )  begin 
          end  
          else  bad_cmd_code; 
          line_number = line_number + 1; 
        end  

        300: begin 
          rc_read = $fscanf ( DATAID, "%d", MODENUM ); 
          if ( rc_read <= 0 )  bad_cmd_code; 
          else  begin 

            case ( MODENUM ) 

              1: begin 
                rc_read = $fscanf ( DATAID, "%d", SCANNUM ); 
                if ( rc_read <= 0 )  bad_cmd_code; 
                else  begin 

                  case ( SCANNUM ) 

                    1: begin 

                      if ( rc_read > 0 )  begin 
                        rc_read = $fscanf ( DATAID, "%b", stim_CR_1 [1:6] ); 
                        if ( rc_read <= 0 )  bad_cmd_code; 
                        line_number = line_number + 1; 
                      end  
                    end  

                  endcase  
                end  
              end  

            endcase  
          end  
        end  

        301: begin 
          rc_read = $fscanf ( DATAID, "%d", MODENUM ); 
          if ( rc_read <= 0 )  bad_cmd_code; 
          else  begin 

            case ( MODENUM ) 

              1: begin 
                rc_read = $fscanf ( DATAID, "%d", SCANNUM ); 
                if ( rc_read <= 0 )  bad_cmd_code; 
                else  begin 

                  case ( SCANNUM ) 

                    1: begin 

                      if ( rc_read > 0 )  begin 
                        rc_read = $fscanf ( DATAID, "%b", meas_OR_1 [1:6] ); 
                        if ( rc_read <= 0 )  bad_cmd_code; 
                        line_number = line_number + 1; 
                      end  
                    end  

                  endcase  
                end  
              end  

            endcase  
          end  
        end  

        400: begin 
          if ( sim_range )  test_cycle; 
          line_number = line_number + 1; 
        end  

        500: begin 
          repeat_depth = repeat_depth + 1; 
          rc_read = $fscanf ( DATAID, "%d", num_repeats [repeat_depth] ); 
          if ( rc_read > 0 )  begin 
            start_of_repeat[repeat_depth] = $ftell ( DATAID ); 
          end  
          else  bad_cmd_code; 
          if ((sim_range & sim_heart) && repeat_heart) 
            $display ( "\nINFO (TVE-202): Simulating pattern %0s at Time %0t.  Start of %0d cycles of a repeat loop.", pattern, $time, num_repeats [repeat_depth] ); 
          line_number = line_number + 1; 
        end  

        501: begin 
          num_repeats [repeat_depth] = num_repeats [repeat_depth] - 1; 
          if ( num_repeats [repeat_depth] )  begin 
            if ((sim_range & sim_heart) && repeat_heart && (num_repeats [repeat_depth] % repeat_heart == 0 )) 
              $display ( "\nINFO (TVE-202): Simulating pattern %0s at Time %0t.  Number of cycles remaining in this repeat loop is %0d.", pattern, $time, num_repeats [repeat_depth] ); 
            rc_read = $fseek ( DATAID, start_of_repeat [repeat_depth], 0 ); 
            rc_read = 1; 
            fseek_offset = $ftell ( DATAID ); 
            if ( fseek_offset != start_of_repeat [repeat_depth] )  begin 
              $display ( "\nERROR (TVE-956): An ncsim limitation in the fseek routine has been reached.  The size of the Verilog Data file is so big that it can not support branching using fseek in ncsim.  Any branching after 2147483647 (0x7fffffff) bytes of data will not run correctly under ncsim.  It is recommended that you break up the Verilog Data file using the keyword maxvectorsperfile.  The Verilog Data file:  %0s  \n", DATAFILE ); 
              rc_read = 0;  // This will stop execution 
            end  
          end  
          else  repeat_depth = repeat_depth - 1; 
          line_number = line_number + 1; 
        end  

        600: begin 
          rc_read = $fscanf ( DATAID, "%d", MODENUM ); 
          if ( rc_read <= 0 )  bad_cmd_code; 
          else  begin 

            case ( MODENUM ) 

              1: begin 
                rc_read = $fscanf ( DATAID, "%d", SEQNUM ); 
                if ( rc_read <= 0 )  bad_cmd_code; 
                else  begin 

                  case ( SEQNUM ) 

                    1: begin 
                      rc_read = $fscanf ( DATAID, "%d", MAX ); 
                      if ( rc_read > 0 )  begin 
                        if ( sim_range )  Scan_Preconditioning_Sequence_TM_1_SEQ_1_SOP_1; 
                      end  
                      else  bad_cmd_code; 
                      line_number = line_number + 1; 
                    end  

                    2: begin 
                      rc_read = $fscanf ( DATAID, "%d", MAX ); 
                      if ( rc_read > 0 )  begin 
                        if ( sim_range )  Scan_Sequence_TM_1_SEQ_2_SOP_1; 
                      end  
                      else  bad_cmd_code; 
                      line_number = line_number + 1; 
                    end  

                  endcase  
                end  
              end 

            endcase  
          end  
        end  

        850: begin 
          rc_read = $fscanf ( DATAID, "%d", TASKNUM ); 
          if ( rc_read <= 0 )  bad_cmd_code; 
          else  begin 

            case ( TASKNUM ) 

              1: begin 
                if ( sim_range )  TBphantomLogicSeq1_20200826025928__0; 
              end  

              2: begin 
                if ( sim_range )  TBphantomLogicSeq1_20200826025928__1; 
              end  

            endcase  
          end  
          line_number = line_number + 1; 
        end  

        900: begin 
          rc_read = $fscanf ( DATAID, "%s", pattern ); 
          if ( rc_read > 0 )  begin 
            if ( SOD == pattern )  begin 
              sim_range = 1'b1; 
            end  
            if (( CMD == 900 ) & sim_range & sim_heart )  $display ( "\nINFO (TVE-202): Simulating pattern %0s at Time %0t. ", pattern, $time ); 
          end  
          else  bad_cmd_code; 
          line_number = line_number + 1; 
        end  

        901: begin 
          rc_read = $fscanf ( DATAID, "%s", PATTERN ); 
          if ( rc_read > 0 )  begin 
          end  
          else  bad_cmd_code; 
          line_number = line_number + 1; 
        end  

        903: begin 
          measure_current = measure_current + 1; 
          line_number = line_number + 1; 
        end  

        904: begin 
          rc_read = $fscanf ( DATAID, "%s", eventID ); 
          if ( rc_read > 0 )  begin 
            `ifdef MISCOMPAREDEBUG 
              if ( diag_debug ) begin 
                $processSimulationDebugFile ( DIAG_DEBUG_FILE, "compteur_inst", eventID ); 
              end 
            `endif 
          end  
          else  bad_cmd_code; 
          line_number = line_number + 1; 
        end  

        905: begin 
          rc_read = $fscanf ( DATAID, "%s", eventID ); 
          if ( rc_read > 0 )  begin 
            `ifdef MISCOMPAREDEBUG 
              if ( diag_debug ) begin 
                $processSimulationDebugFile ( DIAG_DEBUG_FILE, "compteur_inst", eventID ); 
              end 
            `endif 
          end  
          else  bad_cmd_code; 
          line_number = line_number + 1; 
        end  


        default: begin 
          bad_cmd_code; 
          rc_read = 0;  // This will stop execution 
          line_number = line_number + 1; 
        end  

      endcase  

    end  
  endtask  

//***************************************************************************//
//                          PRINT BAD CMD CODE DATA                          //
//***************************************************************************//

  task bad_cmd_code; 
    begin 

      $display ( "\nERROR (TVE-998): Unrecognizable data at line %0.0f in file: %0s \n", line_number, DATAFILE ); 
      start_of_current_line = $ftell ( DATAID ); 
      rc_read = $fgets ( COMMENT, DATAID ); 
      $display ( "  Command code = %0d, Unrecognized data = %0s \n", CMD, COMMENT ); 
      rc_read = 0;  // This will stop execution 

    end  
  endtask  

  endmodule 
